#version 330
uniform vec3 light_position;
uniform vec4 light_color;
uniform vec4 ambient_color;
in vec4 frag_color;
in vec3 world_normal;
in vec4 world_position;
//const vec3 ambient = vec3( 0.1, 0.1, 0.1 );
//const vec3 lightVecNormalized = normalize( vec3( 0.0, 100.0, 0.0 ) );
//const vec3 lightColor = vec3( 1.0, 1.0, 1.0 );
out vec4 fragColor;

void main()
{
	// renormalize and homogenize input variables
	vec3 normal = normalize(world_normal);
	vec3 position = world_position.xyz / world_position.w;
	
	// calculate the light-direction
	vec3 light_dir = normalize(light_position - position);
	
	// calculate lighting
	vec4 ambient = ambient_color * frag_color;
	vec4 diffuse = frag_color * max(0.0, dot(normal, light_dir));
	
	// write color to output
	fragColor = diffuse+ambient_color;
}
